# written by Ed LaFrance, http://www.newmediaems.com

Usertag encrypt Order cmd
Usertag encrypt HasEndTag 1
Usertag encrypt Interpolate 1
Usertag encryp  Documentation <<EOD

usage: [encrypt cmd='/usr/bin/encryptprog -opts key'*]Stuff to encrypt[/encrypt]

* = optional parameter

Allows the encryption of arbitrary data.  The [encrypt][/encrypt] pair can
be surrounded with [seti name][/seti] to store the results in a scratch
variable, written to a database field, emailed etc. The cmd parameter is optional
and can be used to specify an encryption command specifically for use with this
tag; otherwise the value from the EncryptProgram or PGP catalog directives will
be used.

EOD
Usertag encrypt Routine <<EOR
sub {
         my ($cmd, $body) = @_;
         return 'Need something to encrypt!' unless $body;
         $cmd = $Config->{EncryptProgram} || $Vend::Cfg->{PGP} unless $cmd;
         return 'No encryption command found!' unless $cmd;
         my $name = $Tag->data('session', 'id');
         my $fpre = $Vend::Cfg->{ScratchDir} . "/pgp.$name";
         open(PGP, "|$cmd >$fpre.out 2>$fpre.err")
         or die "Couldn't fork: $!";
         print PGP $body;
         close PGP;
         if($?) {
                 my $err = Vend::Util::readfile("$fpre.err");
                 return '<b>Encrypt failed:</b><br>' .  $err;
         }
         $body = Vend::Util::readfile("$fpre.out");
         unlink "$fpre.out";
         unlink "$fpre.err";
         return $body;
}
EOR
